# Конфигурация GIT

Сразу же после установки лучше всего произвести первоначальную настройку Git.

Git имеет три файла конфигурации:
- системный (общий на всю систему, для всех пользователей) */etc/gitconfig* 
- глобальный (для конкретного пользователя) *~/.gitconfig*
- локальный (для конкретного репозитория) *.git/config*

Соответственно для настроек *git config* используется с опциями:
- git config --system
- git cofnig --global
- git config (--local)

Можно редактировать файлы ручками, либо использовать встроенную утилиту *git config*. В общем виде формат вызова выглядит так:

```
git config секция.параметр значение
```

Делаем базовые настройки:
```
git config --global user.name "My name"     # Имя пользователя по умолчанию для всех коммитов
git config --global user.email my@mail.com  # Почта пользователя по умолчанию для всех коммитов
git config --global color.ui true           # Включаем цветной вывод в командах git
git config --global core.quotepath off      # Для правильного отображение русских имен файлов
```

Дополнительно можно настроить удобные элиасы для часто используемых команд.

---
Вот моя конфигурация ~/.gitconfig
```
[user]
	name = ARNik
	email = r.anikeev@gmail.com	
[color]
	ui = true
[core]
	quotepath = off	# отображение русских имен файлов
[alias]
	ll = log --oneline --graph --decorate --all
	st = status --short
	co = checkout
	br = branch
	ct = commit

	lg = log --graph --all\
	--pretty=format:'%Cred%h%Creset -%C(auto)%d %Creset%s %Cgreen(%cr) %C(bold blue)<%an>%Creset'
```
---
Для изучения Git и в качестве справки хочу порекомендовать:
 - [Git: курс](https://www.youtube.com/playlist?list=PLDyvV36pndZFHXjXuwA_NywNrVQO0aQqb)
 - [Git: разное](https://www.youtube.com/playlist?list=PLDyvV36pndZEB7kWWocU4QSn-G78LoaEE)

